

/*
 * Copyright (C) 2012 by
 *   MetraLabs GmbH (MLAB), GERMANY
 * and
 *   Neuroinformatics and Cognitive Robotics Labs (NICR) at TU Ilmenau, GERMANY
 * All rights reserved.
 *
 * Contact: info@mira-project.org
 *
 * Commercial Usage:
 *   Licensees holding valid commercial licenses may use this file in
 *   accordance with the commercial license agreement provided with the
 *   software or, alternatively, in accordance with the terms contained in
 *   a written agreement between you and MLAB or NICR.
 *
 * GNU General Public License Usage:
 *   Alternatively, this file may be used under the terms of the GNU
 *   General Public License version 3.0 as published by the Free Software
 *   Foundation and appearing in the file LICENSE.GPL3 included in the
 *   packaging of this file. Please review the following information to
 *   ensure the GNU General Public License version 3.0 requirements will be
 *   met: http://www.gnu.org/copyleft/gpl.html.
 *   Alternatively you may (at your option) use any later version of the GNU
 *   General Public License if such license has been publicly approved by
 *   MLAB and NICR (or its successors, if any).
 *
 * IN NO EVENT SHALL "MLAB" OR "NICR" BE LIABLE TO ANY PARTY FOR DIRECT,
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
 * THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF "MLAB" OR
 * "NICR" HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * "MLAB" AND "NICR" SPECIFICALLY DISCLAIM ANY WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND "MLAB" AND "NICR" HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS.
 */

/**
 * @file philunitname.C
 *    philunitdescription
 *
 * @author phildomianauthor
 * @date   2015/01/14
 */
#include<fw/Unit.h>
#include<navigation/Task.h>
#include<navigation/tasks/PositionTask.h>
#include<navigation/tasks/OrientationTask.h>
#include<navigation/tasks/PreferredDirectionTask.h>

#include<stdio.h> //printf
#include<string.h> //memset
#include<stdlib.h> //exit(0);
#include<arpa/inet.h>
#include<sys/socket.h>
#include<string.h>



#define BUFLEN 2048  //Max length of buffer
#define PORT 8888   //The port on which to listen for incoming data
using namespace mira;
using namespace mira::navigation;

namespace phildomainname { 

///////////////////////////////////////////////////////////////////////////////

/**
 * philunitdescription
 */
class philunitname : public Unit
{
MIRA_OBJECT(philunitname)

public:

	philunitname();


	template<typename Reflector>
	void reflect(Reflector& r)
	{
		Unit::reflect(r);

		// TODO: reflect all parameters (members and properties) that specify the persistent state of the unit
		//r.property("Param1", mParam1, "First parameter of this unit with default value", 123.4f);
		//r.member("Param2", mParam2, setter(&UnitName::setParam2,this), "Second parameter with setter");
	}


protected:

	virtual void initialize();

	virtual void process(const Timer& timer);

private:

	// void onPoseChanged(ChannelRead<Pose2> pose);

private:

	//Channel<Img<>> mChannel;
};

///////////////////////////////////////////////////////////////////////////////




philunitname::philunitname() : Unit(Duration::milliseconds(250))
{
	// TODO: further initialization of members, etc.
}

void philunitname::initialize()
{
	// TODO: subscribe and publish all required channels
	//subscribe<Pose2>("Pose", &UnitName::onPoseChanged);
	//mChannel = publish<Img<>>("Image");
}

void die(char *s)
{
    perror(s);
    exit(1);
}



void philunitname::process(const Timer& timer)
{
	// TODO: this method is called periodically with the specified cycle time, so you can perform your computation here.

struct sockaddr_in si_me, si_other;
     
    int s, i;
    socklen_t slen = sizeof(si_other) , recv_len;
    char buf[BUFLEN];
    char needle[]="found gesture #4";
    char needle2[]="found gesture #3";
    char needle3[]="found gesture #10";
    char needle4[]="found gesture #11";
    char needle5[]="found gesture #12";
    float headspin0=0;
    float headspin=60;
    float headspin2=-60;
    float eyescenter=0;
    float eyesright=90;
    float eyesleft=-90;

    //create a UDP socket
    if ((s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1)
    {
        die("socket");
    }
     
    // zero out the structure
    memset((char *) &si_me, 0, sizeof(si_me));
     
    si_me.sin_family = AF_INET;
    si_me.sin_port = htons(PORT);
    si_me.sin_addr.s_addr = htonl(INADDR_ANY);
     
    //bind socket to port
    if( bind(s , (struct sockaddr*)&si_me, sizeof(si_me) ) == -1)
    {
        die("bind");
    }
     
    //keep listening for data
    while(1)
    {
        //printf("Waiting for data...");
        fflush(stdout);
         
        //try to receive some data, this is a blocking call
        if ((recv_len = recvfrom(s, buf, BUFLEN, 0, (struct sockaddr *) &si_other, &slen)) == -1)
        {
            die("recvfrom()");
        }
         
        //print details of the client/peer and the data received

        if(strstr(buf,needle))
        {
            printf("Received packet from %s:%d\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
            printf("String enthaelt Found Gesture 4\n");
            callService<void>("/robot/Robot", "moveHeadLeftRight",headspin);
        }
        if(strstr(buf,needle2))
        {
            printf("Received packet from %s:%d\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
            printf("String enthaelt Found Gesture 3\n");
            callService<void>("/robot/Robot", "moveHeadLeftRight",headspin2);
        }

        if(strstr(buf,needle3))
        {
            printf("Received packet from %s:%d\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
            printf("String enthaelt Found Gesture 10\n");

            callService<void>("/robot/Robot", "moveEyesLeftRight", eyescenter);
            printf("Eyes Center\n");                            //Kontrolle Programmablauf
            callService<void>("/robot/Robot", "moveHeadLeftRight", headspin0);
            printf("Head Center\n");                            //Kontrolle Programmablauf


            TaskPtr task(new Task());
            task->addSubTask(SubTaskPtr(new PositionTask(Point2f(0.0f, 0.0f), 0.2f, 0.3f)));     //x-coordinate, y-coordinate, x-tolerance, y-tolerance in m
            task->addSubTask(SubTaskPtr(new OrientationTask(deg2rad(180.0f), deg2rad(15.0f))));  //richtung, toleranz
            task->addSubTask(SubTaskPtr(new PreferredDirectionTask(PreferredDirectionTask::FORWARD, 0.5f)));

            callService<void>("/navigation/Pilot", "setTask", task);

        }

        if(strstr(buf,needle4))     //fahrt und dreht sich anschliessend um 180degree und bewegt dann ihr linkes Auge
        {
            printf("Received packet from %s:%d\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
            printf("String enthaelt Found Gesture 11\n");

            TaskPtr task(new Task());
            task->addSubTask(SubTaskPtr(new PositionTask(Point2f(2.5f, -5.0f), 0.2f, 0.3f)));     //x-coordinate, y-coordinate, x-tolerance, y-tolerance in m
            task->addSubTask(SubTaskPtr(new OrientationTask(deg2rad(180.0f), deg2rad(15.0f))));  //richtung, toleranz
            task->addSubTask(SubTaskPtr(new PreferredDirectionTask(PreferredDirectionTask::FORWARD, 0.5f)));

            callService<void>("/robot/Robot", "moveEyesLeftRight", eyesleft);
            callService<void>("/navigation/Pilot", "setTask", task);
        }


        if(strstr(buf,needle5))
                {
                    printf("Received packet from %s:%d\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
                    printf("String enthaelt Found Gesture 12\n");
                    //callService<void>("/robot/Robot", "moveEyesLeftRight", eyesright);

                    TaskPtr task(new Task());
                    task->addSubTask(SubTaskPtr(new PositionTask(Point2f(2.5f, -5.0f), 0.2f, 0.3f)));     //x-coordinate, y-coordinate, x-tolerance, y-tolerance in m
                    task->addSubTask(SubTaskPtr(new OrientationTask(deg2rad(180.0f), deg2rad(15.0f))));  //richtung, toleranz
                    task->addSubTask(SubTaskPtr(new PreferredDirectionTask(PreferredDirectionTask::FORWARD, 0.5f)));
                    callService<void>("/navigation/Pilot", "setTask", task);
                }
       // else
     //   {
       // printf("Received packet from %s:%d\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
       // printf("Data: %s\n" , buf);
      //  }
        //now reply the client with the same data
        if (sendto(s, buf, recv_len, 0, (struct sockaddr*) &si_other, slen) == -1)
        {
            die("sendto()");
        }
    }
 
    close(s);
    
}

///////////////////////////////////////////////////////////////////////////////

}

MIRA_CLASS_SERIALIZATION(phildomainname::philunitname, mira::Unit );
